Index: LMDZ6/trunk/libf/phylmd/lscp_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/lscp_mod.F90	(revision 4380)
+++ LMDZ6/trunk/libf/phylmd/lscp_mod.F90	(revision 4392)
@@ -329,4 +329,7 @@
 fcontrP(:,:) = 0.0
 
+!c_iso: variable initialisation for iso 
+
+
 !===============================================================================
 !              BEGINNING OF VERTICAL LOOP FROM TOP TO BOTTOM
@@ -341,4 +344,5 @@
         zt(i)=t(i,k)
         zq(i)=q(i,k)
+        !c_iso init of iso
     ENDDO
     
@@ -390,5 +394,5 @@
     ! --------------------------------------------------------------------
 
-    IF (iflag_evap_prec.GE.1) THEN
+    IF (iflag_evap_prec.GE.1) THEN ! useless -> to be removed
 
         ! Calculation of saturation specific humidity
@@ -406,4 +410,6 @@
 
             ! LTP: we only account for precipitation evaporation in the clear-sky (iflag_evap_prec=4).
+            ! c_iso: likely important to distinguish cs from neb isotope precipitation
+
                 IF (iflag_evap_prec.EQ.4) THEN
                     zrfl(i) = zrflclr(i)
@@ -478,9 +484,10 @@
 
 
-                ! New solid and liquid precipitation fluxes
+                ! New solid and liquid precipitation fluxes after evap and sublimation
                 zrfln(i) = Max(0.,zrfl(i) - zqev*(paprs(i,k)-paprs(i,k+1))  &
                          /RG/dtime)
                 zifln(i) = Max(0.,zifl(i) - zqevi*(paprs(i,k)-paprs(i,k+1)) &
                          /RG/dtime)
+
 
                 ! vapor, temperature, precip fluxes update
@@ -501,4 +508,8 @@
                 zifl(i) = zifln(i)
 
+                ! c_iso here call_reevap that updates isotopic zrfl, zifl (in inout)
+                !                         due to evap + sublim                                     
+                                           
+
                 IF (iflag_evap_prec.EQ.4) THEN
                     zrflclr(i) = zrfl(i)
@@ -511,9 +522,11 @@
                 ENDIF
 
-
-                ! CR Be careful: ice melting has been moved
+                ! c_iso duplicate for isotopes or loop on isotopes
+
+                ! Melting:
                 zmelt = ((zt(i)-273.15)/(ztfondue-273.15)) ! JYG
                 ! precip fraction that is melted
                 zmelt = MIN(MAX(zmelt,0.),1.)
+
                 ! Ice melting
                 IF (iflag_evap_prec.EQ.4) THEN
@@ -524,4 +537,5 @@
                     zrfl(i)=zrfl(i)+zmelt*zifl(i)
                 ENDIF
+                ! c_iso: melting of isotopic precipi with zmelt (no fractionation)
 
                 ! Latent heat of melting with precipitation thermalization
@@ -536,4 +550,5 @@
                     zifl(i)=zifl(i)*(1.-zmelt)
                 ENDIF
+                !c_iso: same for isotopic precip.
 
             ELSE
@@ -563,4 +578,5 @@
                 zq(i)=1.e-15
             ENDIF
+            ! c_iso: do something similar for isotopes
 
      ENDDO
@@ -826,4 +842,7 @@
             ENDIF
 
+            ! c_iso : routine that computes in-cloud supersaturation
+            ! c_iso condensation of isotopes (zcond, zsursat, zfice, zq in input) 
+
             ! temperature update due to phase change
             zt(i) = zt(i) + (1.-zfice(i))*zcond(i) & 
@@ -885,4 +904,5 @@
                 ziflclr(i) = ziflclr(i) + d_zifl_cld_clr(i) - d_zifl_clr_cld(i)
 
+                ! c_iso  do the same thing for isotopes precip
         ENDDO
     ENDIF
@@ -894,4 +914,5 @@
             zoliqi(i)= zoliq(i)*zfice(i)
             zoliql(i)= zoliq(i)*(1.-zfice(i))
+            ! c_iso : initialisation of zoliq* also for isotopes
             zrho(i,k)  = pplay(i,k) / zt(i) / RD
             zdz(i)   = (paprs(i,k)-paprs(i,k+1)) / (zrho(i,k)*RG)
@@ -925,4 +946,5 @@
                 zsnow=0.
                 zprecip=0.
+                ! c_iso same init for isotopes. Externalisation?
 
                 IF (zneb(i).EQ.seuil_neb) THEN
@@ -949,4 +971,6 @@
                     ! reduces the in-cloud water).
 
+
+                    ! warning: here should be zoliql?
                     IF ((iflag_cloudth_vert.GE.3).AND.(iflag_rain_incloud_vol.EQ.1)) THEN
                         zchau = zct   *dtime/REAL(ninter) * zoliq(i) &
@@ -966,4 +990,6 @@
                 zoliqi(i) = MAX(zoliq(i)*zfice(i)-1.*zsnow  , 0.0)
                 zoliq(i)  = MAX(zoliq(i)-zprecip , 0.0)
+
+                ! c_iso: call isotope_conversion (for readibility) or duplicate 
 
                 radliq(i,k) = radliq(i,k) + zoliq(i)/REAL(ninter+1)
@@ -1021,4 +1047,6 @@
                     zqpreci(i) = max (zqpreci(i) - Deltaqprecl - Deltaq, 0.)
 
+                    ! c_iso : mv here condensation of isotopes + redispatchage en precip 
+
                 IF (iflag_evap_prec.EQ.4) THEN
                     zrflcld(i) = zrflcld(i)+zqprecl(i) &
@@ -1035,4 +1063,5 @@
                    *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
                 ENDIF
+                ! c_iso : same for isotopes
  
            ENDIF ! rneb>0
@@ -1076,4 +1105,5 @@
         d_qi(i,k) = zfice(i)*zoliq(i)
         d_q(i,k) = zq(i) - q(i,k)
+        ! c_iso: same for isotopes
         d_t(i,k) = zt(i) - t(i,k)
     ENDDO
@@ -1191,4 +1221,5 @@
       snow(i) = zifl(i)
       rain(i) = zrfl(i)
+      ! c_iso final output
   ENDDO
 