Index: /LMDZ6/trunk/DefLists/field_def_lmdz.xml
===================================================================
--- /LMDZ6/trunk/DefLists/field_def_lmdz.xml	(revision 4411)
+++ /LMDZ6/trunk/DefLists/field_def_lmdz.xml	(revision 4412)
@@ -583,6 +583,6 @@
         <field id="concdust"    long_name="Concentration of Dust "    unit="kg/m3" />
         <field id="ec550aer"    long_name="Extinction at 550nm"    unit="m^-1" />
-        <field id="lwcon"    long_name="Cloud liquid water content"    unit="kg/kg" />
-        <field id="iwcon"    long_name="Cloud ice water content"    unit="kg/kg" />
+        <field id="lwcon"    long_name="Cloud liquid water content seen by radiation"    unit="kg/kg" />
+        <field id="iwcon"    long_name="Cloud ice water content seen by radiation"    unit="kg/kg" />
         <field id="temp"    long_name="Air temperature"    unit="K" />
         <field id="theta"    long_name="Potential air temperature"    unit="K" />
Index: /LMDZ6/trunk/libf/phylmd/lscp_ini_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/lscp_ini_mod.F90	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/lscp_ini_mod.F90	(revision 4412)
@@ -35,6 +35,6 @@
   !$OMP THREADPRIVATE(iflag_mpc_bl)
   
-  LOGICAL, SAVE :: ok_radliq_snow=.false.       ! take into account the mass of ice precip in the cloud ice content seen by radiation
-  !$OMP THREADPRIVATE(ok_radliq_snow)
+  LOGICAL, SAVE :: ok_radocond_snow=.false.       ! take into account the mass of ice precip in the cloud ice content seen by radiation
+  !$OMP THREADPRIVATE(ok_radocond_snow)
 
 
@@ -56,5 +56,5 @@
     CALL getin_p('rain_int_min',rain_int_min) 
     CALL getin_p('iflag_mpc_bl',iflag_mpc_bl)
-    CALL getin_p('ok_radliq_snow',ok_radliq_snow)         
+    CALL getin_p('ok_radocond_snow',ok_radocond_snow)         
     WRITE(lunout,*) 'lscp, ninter:', ninter
     WRITE(lunout,*) 'lscp, iflag_evap_prec:', iflag_evap_prec
@@ -62,5 +62,5 @@
     WRITE(lunout,*) 'lscp, rain_int_min:', rain_int_min
     WRITE(lunout,*) 'lscp, iflag_mpc_bl:', iflag_mpc_bl
-    WRITE(lunout,*) 'lscp, ok_radliq_snow:', ok_radliq_snow
+    WRITE(lunout,*) 'lscp, ok_radocond_snow:', ok_radocond_snow
     
     ! check for precipitation sub-time steps
Index: /LMDZ6/trunk/libf/phylmd/lscp_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/lscp_mod.F90	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/lscp_mod.F90	(revision 4412)
@@ -9,5 +9,5 @@
      paprs,pplay,t,q,ptconv,ratqs,                      &
      d_t, d_q, d_ql, d_qi, rneb, rneblsvol, rneb_seri,  &
-     radliq, radicefrac, rain, snow,                    &
+     radocond, radicefrac, rain, snow,                    &
      frac_impa, frac_nucl, beta,                        &
      prfl, psfl, rhcl, zqta, fraca,                     &
@@ -41,7 +41,10 @@
 ! References: 
 !
+! - Bony, S., & Emanuel, K. A. 2001, JAS, doi: 10.1175/1520-0469(2001)058<3158:APOTCA>2.0.CO;2
 ! - Hourdin et al. 2013, Clim Dyn, doi:10.1007/s00382-012-1343-y
 ! - Jam et al. 2013, Boundary-Layer Meteorol, doi:10.1007/s10546-012-9789-3
+! - Jouhaud, et al. 2018. JAMES, doi:10.1029/2018MS001379
 ! - Madeleine et al. 2020, JAMES, doi:10.1029/2020MS002046
+! - Touzze-Peifert Ludo, PhD thesis, p117-124
 ! -------------------------------------------------------------------------------
 ! Code structure:
@@ -50,11 +53,9 @@
 ! P1>     Evaporation of the precipitation (falling from the k+1 level)
 ! P2>     Cloud formation (at the k level) 
-! P2.A.0> Cloud properties calculation from a rectangular pdf
-! P2.A.1> With the new PDFs, calculation of cloud properties using the inital
+! P2.A.1> With the PDFs, calculation of cloud properties using the inital
 !         values of T and Q
 ! P2.A.2> Coupling between condensed water and temperature
 ! P2.A.3> Calculation of final quantities associated with cloud formation
-! P2.B>   'All or nothing' cloud
-! P2.C>   Release of Latent heat after cloud formation
+! P2.B>   Release of Latent heat after cloud formation
 ! P3>     Autoconversion to precipitation (k-level)
 ! P4>     Wet scavenging
@@ -65,5 +66,5 @@
 ! water used in the physics and the dynamics 
 ! 
-! During the autoconversion to precipitation (P3 step), radliq (cloud water used
+! During the autoconversion to precipitation (P3 step), radocond (cloud water used
 ! by the radiation scheme) is calculated as an average of the water that remains
 ! in the cloud during the precipitation and not the water remaining at the end
@@ -75,11 +76,12 @@
 ! Radiation:
 ! xflwc(newmicro)+xfiwc(newmicro) =
-!   cldliq(physiq)=radliq(fisrt)=lwcon(nc)+iwcon(nc)
+!   radocond=lwcon(nc)+iwcon(nc)
 !
 ! Notetheless, be aware of:
 !
-! radliq(fisrt) .NE. ocond(nc)
+! radocond .NE. ocond(nc)
 ! i.e.:
 ! lwcon(nc)+iwcon(nc) .NE. ocond(nc)
+! but oliq+(ocond-oliq) .EQ. ocond
 ! (which is not trivial)
 !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@ -91,5 +93,5 @@
 
 USE lscp_ini_mod, ONLY : seuil_neb, ninter, iflag_evap_prec, t_coup, DDT0, ztfondue, rain_int_min
-USE lscp_ini_mod, ONLY : iflag_mpc_bl, ok_radliq_snow, a_tr_sca
+USE lscp_ini_mod, ONLY : iflag_mpc_bl, ok_radocond_snow, a_tr_sca
 
 
@@ -115,5 +117,5 @@
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: pplay           ! mid-layer pressure [Pa]
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: t               ! temperature (K)
-  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: q               ! specific humidity [kg/kg] 
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: q               ! total specific humidity (= vapor phase) [kg/kg] 
   INTEGER,                         INTENT(IN)   :: iflag_cld_th    ! flag that determines the distribution of convective clouds
   INTEGER,                         INTENT(IN)   :: iflag_ice_thermo! flag to activate the ice thermodynamics
@@ -152,9 +154,9 @@
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rneb             ! cloud fraction [-]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rneblsvol        ! cloud fraction per unit volume [-]  
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: radliq           ! condensed water used in the radiation scheme [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: radocond         ! condensed water used in the radiation scheme [kg/kg]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: radicefrac       ! ice fraction of condensed water for radiation scheme
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: rhcl             ! clear-sky relative humidity [-]
-  REAL, DIMENSION(klon),           INTENT(OUT)  :: rain             ! large-scale rainfall [kg/s/m2] 
-  REAL, DIMENSION(klon),           INTENT(OUT)  :: snow             ! large-scale snowfall [kg/s/m2]
+  REAL, DIMENSION(klon),           INTENT(OUT)  :: rain             ! surface large-scale rainfall [kg/s/m2] 
+  REAL, DIMENSION(klon),           INTENT(OUT)  :: snow             ! surface large-scale snowfall [kg/s/m2]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsatl            ! saturation specific humidity wrt liquid [kg/kg]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qsats            ! saturation specific humidity wrt ice [kg/kg]  
@@ -231,5 +233,5 @@
   REAL velo(klon,klev), vr
   REAL qlmpc, qimpc, rnebmpc
-  REAL radliqi(klon,klev), radliql(klon,klev)
+  REAL radocondi(klon,klev), radocondl(klon,klev)
 
   INTEGER i, k, n, kk
@@ -295,5 +297,5 @@
 d_qi(:,:) = 0.0
 rneb(:,:) = 0.0
-radliq(:,:) = 0.0
+radocond(:,:) = 0.0
 radicefrac(:,:) = 0.0
 frac_nucl(:,:) = 1.0 
@@ -350,11 +352,15 @@
     ! P0> Thermalization of precipitation falling from the overlying layer
     ! --------------------------------------------------------------------
-    ! Computes air temperature variation due to latent heat transported by
+    ! Computes air temperature variation due to enthalpy transported by
     ! precipitation. Precipitation is then thermalized with the air in the
     ! layer. 
     ! The precipitation should remain thermalized throughout the different
-    ! thermodynamical transformations. The corresponding water mass should
+    ! thermodynamical transformations. 
+    ! The corresponding water mass should
     ! be added when calculating the layer's enthalpy change with 
     ! temperature
+    ! See lmdzpedia page todoan
+    ! todoan: check consistency with ice phase
+    ! todoan: understand why several steps
     ! ---------------------------------------------------------------------
     
@@ -409,5 +415,5 @@
             IF (zrfl(i)+zifl(i).GT.0.) THEN
 
-            ! LTP: we only account for precipitation evaporation in the clear-sky (iflag_evap_prec=4).
+            ! LudoTP: we only account for precipitation evaporation in the clear-sky (iflag_evap_prec=4).
             ! c_iso: likely important to distinguish cs from neb isotope precipitation
 
@@ -475,4 +481,5 @@
                 ! redistribute zqev0 conserving the ratio liquid/ice 
 
+                ! todoan: check the consistency of this formula
                 IF (zqevt+zqevti.GT.zqev0) THEN
                     zqev=zqev0*zqevt/(zqevt+zqevti)
@@ -494,4 +501,5 @@
                 zq(i) = zq(i) - (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
                 * (RG/(paprs(i,k)-paprs(i,k+1)))*dtime
+
                 ! precip thermalization
                 zmqc(i) = zmqc(i) + (zrfln(i)+zifln(i)-zrfl(i)-zifl(i)) &
@@ -525,16 +533,25 @@
 
                 ! Melting:
-                zmelt = ((zt(i)-273.15)/(ztfondue-273.15)) ! JYG
+                zmelt = ((zt(i)-RTT)/(ztfondue-RTT)) ! JYG
                 ! precip fraction that is melted
                 zmelt = MIN(MAX(zmelt,0.),1.)
 
-                ! Ice melting
+                ! update of rainfall and snowfall due to melting
                 IF (iflag_evap_prec.EQ.4) THEN
                     zrflclr(i)=zrflclr(i)+zmelt*ziflclr(i)
                     zrflcld(i)=zrflcld(i)+zmelt*ziflcld(i)
                     zrfl(i)=zrflclr(i)+zrflcld(i)
+
+                    ziflclr(i)=ziflclr(i)*(1.-zmelt)
+                    ziflcld(i)=ziflcld(i)*(1.-zmelt)
+                    zifl(i)=ziflclr(i)+ziflcld(i)
+
                 ELSE
                     zrfl(i)=zrfl(i)+zmelt*zifl(i)
-                ENDIF
+
+                    zifl(i)=zifl(i)*(1.-zmelt)
+                ENDIF
+
+
                 ! c_iso: melting of isotopic precipi with zmelt (no fractionation)
 
@@ -543,12 +560,4 @@
                 *RLMLT/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))
                 
-                IF (iflag_evap_prec.EQ.4) THEN
-                    ziflclr(i)=ziflclr(i)*(1.-zmelt)
-                    ziflcld(i)=ziflcld(i)*(1.-zmelt)
-                    zifl(i)=ziflclr(i)+ziflcld(i)
-                ELSE
-                    zifl(i)=zifl(i)*(1.-zmelt)
-                ENDIF
-                !c_iso: same for isotopic precip.
 
             ELSE
@@ -908,5 +917,5 @@
     ENDIF
 
-    ! Initialisation of zoliq and radliq variables
+    ! Initialisation of zoliq and radocond variables
 
     DO i = 1, klon
@@ -919,8 +928,8 @@
             iwc(i)   = 0. 
             zneb(i)  = MAX(rneb(i,k),seuil_neb)
-            radliq(i,k) = zoliq(i)/REAL(ninter+1)
+            radocond(i,k) = zoliq(i)/REAL(ninter+1)
             radicefrac(i,k) = zfice(i)
-            radliqi(i,k)=zoliq(i)*zfice(i)/REAL(ninter+1)
-            radliql(i,k)=zoliq(i)*(1.-zfice(i))/REAL(ninter+1)
+            radocondi(i,k)=zoliq(i)*zfice(i)/REAL(ninter+1)
+            radocondl(i,k)=zoliq(i)*(1.-zfice(i))/REAL(ninter+1)
     ENDDO
 
@@ -992,7 +1001,7 @@
                 ! c_iso: call isotope_conversion (for readibility) or duplicate 
 
-                radliq(i,k) = radliq(i,k) + zoliq(i)/REAL(ninter+1)
-                radliql(i,k) = radliql(i,k) + zoliql(i)/REAL(ninter+1)
-                radliqi(i,k) = radliqi(i,k) + zoliqi(i)/REAL(ninter+1)
+                radocond(i,k) = radocond(i,k) + zoliq(i)/REAL(ninter+1)
+                radocondl(i,k) = radocondl(i,k) + zoliql(i)/REAL(ninter+1)
+                radocondi(i,k) = radocondi(i,k) + zoliqi(i)/REAL(ninter+1)
 
             ENDIF ! rneb >0
@@ -1109,11 +1118,11 @@
 
     ! Calculation of the concentration of condensates seen by the radiation scheme
-    ! for liquid phase, we take radliql
-    ! for ice phase, we take radliqi if we neglect snowfall, otherwise (ok_radliq_snow=true) 
-    ! we recaulate radliqi to account for contributions from the precipitation flux
-
-    IF ((ok_radliq_snow) .AND. (k .LT. klev)) THEN
+    ! for liquid phase, we take radocondl
+    ! for ice phase, we take radocondi if we neglect snowfall, otherwise (ok_radocond_snow=true) 
+    ! we recaulate radocondi to account for contributions from the precipitation flux
+
+    IF ((ok_radocond_snow) .AND. (k .LT. klev)) THEN
         ! for the solid phase (crystals + snowflakes)
-        ! we recalculate radliqi by summing
+        ! we recalculate radocondi by summing
         ! the ice content calculated in the mesh
         ! + the contribution of the non-evaporated snowfall 
@@ -1121,16 +1130,16 @@
         DO i=1,klon
            IF (ziflprev(i) .NE. 0.0) THEN
-              radliqi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)+ziflprev(i)/zrho(i,k+1)/velo(i,k+1)
+              radocondi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)+ziflprev(i)/zrho(i,k+1)/velo(i,k+1)
            ELSE
-              radliqi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)
+              radocondi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)
            ENDIF
-           radliq(i,k)=radliql(i,k)+radliqi(i,k)
+           radocond(i,k)=radocondl(i,k)+radocondi(i,k)
         ENDDO
     ENDIF
 
-    ! caculate the percentage of ice in "radliq" so cloud+precip seen by the radiation scheme
+    ! caculate the percentage of ice in "radocond" so cloud+precip seen by the radiation scheme
     DO i=1,klon
-        IF (radliq(i,k) .GT. 0.) THEN
-            radicefrac(i,k)=MIN(MAX(radliqi(i,k)/radliq(i,k),0.),1.)
+        IF (radocond(i,k) .GT. 0.) THEN
+            radicefrac(i,k)=MIN(MAX(radocondi(i,k)/radocond(i,k),0.),1.)
         ENDIF
     ENDDO
Index: /LMDZ6/trunk/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 4412)
@@ -1413,7 +1413,7 @@
     'ec550aer', 'Extinction at 550nm', 'm^-1', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_lwcon = ctrl_out((/ 2, 5, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'lwcon', 'Cloud liquid water content', 'kg/kg', (/ ('', i=1, 10) /))
+    'lwcon', 'Cloud liquid water content seen by radiation', 'kg/kg', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_iwcon = ctrl_out((/ 2, 5, 10, 10, 10, 10, 11, 11, 11, 11/), &
-    'iwcon', 'Cloud ice water content', 'kg/kg', (/ ('', i=1, 10) /))
+    'iwcon', 'Cloud ice water content seen by radiation', 'kg/kg', (/ ('', i=1, 10) /))
   TYPE(ctrl_out), SAVE :: o_temp = ctrl_out((/ 2, 3, 4, 10, 10, 10, 11, 11, 11, 11/), &
     'temp', 'Air temperature', 'K', (/ ('', i=1, 10) /))
Index: /LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4412)
@@ -827,5 +827,5 @@
     REAL dialiq(klon,klev)  ! eau liquide nuageuse
     REAL diafra(klon,klev)  ! fraction nuageuse
-    REAL cldliq(klon,klev)  ! eau liquide nuageuse
+    REAL radocond(klon,klev)  ! eau condensee nuageuse
     !
     !XXX PB 
@@ -3637,5 +3637,5 @@
          t_seri, q_seri,ptconv,ratqs, &
          d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, rneblsvol, rneb_seri, & 
-         cldliq, picefra, rain_lsc, snow_lsc, &
+         radocond, picefra, rain_lsc, snow_lsc, &
          frac_impa, frac_nucl, beta_prec_fisrt, &
          prfl, psfl, rhcl,  &
@@ -3649,5 +3649,5 @@
     CALL fisrtilp(phys_tstep,paprs,pplay, &
          t_seri, q_seri,ptconv,ratqs, &
-         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, cldliq, &
+         d_t_lsc, d_q_lsc, d_ql_lsc, d_qi_lsc, rneb, radocond, &
          rain_lsc, snow_lsc, &
          pfrac_impa, pfrac_nucl, pfrac_1nucl, &
@@ -3696,5 +3696,5 @@
           cldfra(i,k) = rneb(i,k)
           !CR: a quoi ca sert? Faut-il ajouter qs_seri?
-          IF (.NOT.new_oliq) cldliq(i,k) = ql_seri(i,k)
+          IF (.NOT.new_oliq) radocond(i,k) = ql_seri(i,k)
        ENDDO
     ENDDO
@@ -3760,5 +3760,5 @@
           DO i = 1, klon
              IF (diafra(i,k).GT.cldfra(i,k)) THEN
-                cldliq(i,k) = dialiq(i,k)
+                radocond(i,k) = dialiq(i,k)
                 cldfra(i,k) = diafra(i,k)
              ENDIF
@@ -3797,9 +3797,9 @@
                 DO i=1,klon
                    IF (ptconv(i,k).AND.ptconvth(i,k)) THEN
-                      cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
+                      radocond(i,k)=radocond(i,k)+rnebcon(i,k)*clwcon(i,k)
                       cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
                    ELSE IF (ptconv(i,k)) THEN
                       cldfra(i,k)=rnebcon(i,k)
-                      cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
+                      radocond(i,k)=rnebcon(i,k)*clwcon(i,k)
                    ENDIF
                 ENDDO
@@ -3810,5 +3810,5 @@
                 DO i=1,klon
                    cldfra(i,k)=min(cldfra(i,k)+rnebcon(i,k),1.)
-                   cldliq(i,k)=cldliq(i,k)+rnebcon(i,k)*clwcon(i,k)
+                   radocond(i,k)=radocond(i,k)+rnebcon(i,k)*clwcon(i,k)
                 ENDDO
              ENDDO
@@ -3828,5 +3828,5 @@
                    IF (ptconv(i,k).AND. .NOT.ptconvth(i,k)) THEN
                       cldfra(i,k)=rnebcon(i,k)
-                      cldliq(i,k)=rnebcon(i,k)*clwcon(i,k)
+                      radocond(i,k)=rnebcon(i,k)*clwcon(i,k)
                    ENDIF
                 ENDDO
@@ -3839,5 +3839,5 @@
           ! Ancienne version
           cldfra(:,:)=min(max(cldfra(:,:),rnebcon(:,:)),1.)
-          cldliq(:,:)=cldliq(:,:)+rnebcon(:,:)*clwcon(:,:)
+          radocond(:,:)=radocond(:,:)+rnebcon(:,:)*clwcon(:,:)
        ENDIF
 
@@ -3859,5 +3859,5 @@
           DO i = 1, klon
              IF (diafra(i,k).GT.cldfra(i,k)) THEN
-                cldliq(i,k) = dialiq(i,k)
+                radocond(i,k) = dialiq(i,k)
                 cldfra(i,k) = diafra(i,k)
              ENDIF
@@ -4168,5 +4168,5 @@
           ENDIF
           CALL newmicro (flag_aerosol, ok_cdnc, bl95_b0, bl95_b1, &
-               paprs, pplay, t_seri, cldliq, picefra, cldfra, &
+               paprs, pplay, t_seri, radocond, picefra, cldfra, &
                cldtau, cldemi, cldh, cldl, cldm, cldt, cldq, &
                flwp, fiwp, flwc, fiwc, &
@@ -4176,5 +4176,5 @@
        ELSE
           CALL nuage (paprs, pplay, &
-               t_seri, cldliq, picefra, cldfra, cldtau, cldemi, &
+               t_seri, radocond, picefra, cldfra, cldtau, cldemi, &
                cldh, cldl, cldm, cldt, cldq, &
                ok_aie, &
@@ -5003,5 +5003,5 @@
          presnivs, pphis,     pphi,     albsol1, &
          sh_in,   ch_in,    rhcl,      cldfra,   rneb, &
-         diafra,   cldliq,    itop_con, ibas_con, &
+         diafra,   radocond,    itop_con, ibas_con, &
          pmflxr,   pmflxs,    prfl,     psfl, &
          da,       phi,       mp,       upwd, &
Index: /LMDZ6/trunk/libf/phylmd/phytrac_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phytrac_mod.F90	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/phytrac_mod.F90	(revision 4412)
@@ -184,5 +184,5 @@
     REAL,DIMENSION(klon),INTENT(IN)        :: pphis
     REAL,DIMENSION(klev),INTENT(IN)        :: presnivs 
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau liquide nuageuse
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau condensee totale
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldfra  ! fraction nuageuse (tous les nuages)
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: diafra  ! fraction nuageuse (convection ou stratus artificiels)
Index: /LMDZ6/trunk/libf/phylmd/tracinca_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/tracinca_mod.F90	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/tracinca_mod.F90	(revision 4412)
@@ -89,5 +89,5 @@
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: pphi    ! geopotentiel
     REAL,DIMENSION(klon),INTENT(IN)        :: pphis
-    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau liquide nuageuse
+    REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldliq  ! eau condensee pour le radiatif
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: cldfra  ! fraction nuageuse (tous les nuages)
     REAL,DIMENSION(klon,klev),INTENT(IN)   :: diafra  ! fraction nuageuse (convection ou stratus artificiels)
Index: /LMDZ6/trunk/libf/phylmd/write_bilKP_ave.h
===================================================================
--- /LMDZ6/trunk/libf/phylmd/write_bilKP_ave.h	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/write_bilKP_ave.h	(revision 4412)
@@ -49,5 +49,5 @@
       CALL histwrite_phy(nid_bilKPave,"play",itau_w,paprs)
 c
-cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, cldliq, zx_tmp_3d)
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, radocond, zx_tmp_3d)
       CALL histwrite_phy(nid_bilKPave,"oliq",itau_w,cldliq)
 c
Index: /LMDZ6/trunk/libf/phylmd/write_bilKP_ins.h
===================================================================
--- /LMDZ6/trunk/libf/phylmd/write_bilKP_ins.h	(revision 4411)
+++ /LMDZ6/trunk/libf/phylmd/write_bilKP_ins.h	(revision 4412)
@@ -49,5 +49,5 @@
       CALL histwrite_phy(nid_bilKPins,"play",itau_w,paprs)
 c
-cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, cldliq, zx_tmp_3d)
+cym      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, radocond, zx_tmp_3d)
       CALL histwrite_phy(nid_bilKPins,"oliq",itau_w,cldliq)
 c