Index: BOL/script_install/install_lmdz.sh
===================================================================
--- BOL/script_install/install_lmdz.sh	(revision 4422)
+++ BOL/script_install/install_lmdz.sh	(revision 4427)
@@ -955,4 +955,38 @@
 ############################################################
 
+
+
+cd $MODEL/modipsl/modeles/LMDZ*
+lmdzlog=`pwd`/lmdz.log
+
+##################################################################
+# Possibly update LMDZ if a specific svn release is requested
+##################################################################
+
+set +e ; svn upgrade ; set -e
+
+if [ "$svn" = "last" ] ; then svnopt="" ; else svnopt="-r $svn" ; fi
+if [ "$svn" != "" ] ; then
+    set +e ; svn info | grep -q 'http:'
+    if [ $? = 0 ] ; then
+        svn switch --relocate http://svn.lmd.jussieu.fr/LMDZ \
+            https://svn.lmd.jussieu.fr/LMDZ
+    fi
+    svn update $svnopt
+    set -e
+fi
+
+#---------------------------------------------------------------------
+# Retrieve the final svn release number, and adjust compilation
+# options accordingly
+# If svn not available, will use the svn writen in $MODEL/Readm*md
+# For old version it assumes that it is before 4185 (the version
+# for which the test was introduced
+#---------------------------------------------------------------------
+
+set +e ; mysvn=`svnversion . | egrep -o "[0-9]+" 2>/dev/null` ; set -e
+if [ "$mysvn" = "" ] ; then mysvn=`grep 'Revision: [0-9]' $MODEL/Read*.md | awk ' { print $2 } ' 2>/dev/null` ; fi
+if [ "$mysvn" = "" ] ; then mysvn=4190 ; fi
+
 if [[ "$pclinux" = "1" && ! -f arch/arch-local.path ]] ; then
 
@@ -960,15 +994,33 @@
     cd arch
     # arch-local.path file
-    echo "NETCDF_LIBDIR=\"-L${ncdfdir}/lib -lnetcdff -lnetcdf\"" \
+    # test for version as arch.pth file changed format with rev 4426
+    if [ "$mysvn" -gt 4425 ] ; then
+      echo "NETCDF_LIBDIR=\"-L${ncdfdir}/lib \"" > arch-local.path
+      echo "NETCDF_LIB=\"-lnetcdff -lnetcdf\"" >> arch-local.path
+      echo "NETCDF_INCDIR=-I${ncdfdir}/include" >> arch-local.path
+      echo 'NETCDF95_INCDIR=-I$LMDGCM/../../include' >> arch-local.path
+      echo 'NETCDF95_LIBDIR=-L$LMDGCM/../../lib' >> arch-local.path
+      echo 'NETCDF95_LIB=-lnetcdf95' >> arch-local.path
+      echo 'IOIPSL_INCDIR=-I$LMDGCM/../../lib' >> arch-local.path
+      echo 'IOIPSL_LIBDIR=-L$LMDGCM/../../lib' >> arch-local.path
+      echo 'IOIPSL_LIB=-lioipsl' >> arch-local.path
+      echo 'XIOS_INCDIR=-I$LMDGCM/../XIOS/inc' >> arch-local.path
+      echo 'XIOS_LIBDIR=-L$LMDGCM/../XIOS/lib' >> arch-local.path
+      echo "XIOS_LIB=\"-lxios -lstdc++\"" >> arch-local.path
+      echo 'ORCH_INCDIR=-I$LMDGCM/../../lib' >> arch-local.path
+      echo 'ORCH_LIBDIR=-L$LMDGCM/../../lib' >> arch-local.path
+    else
+      echo "NETCDF_LIBDIR=\"-L${ncdfdir}/lib -lnetcdff -lnetcdf\"" \
          > arch-local.path
-    echo "NETCDF_INCDIR=-I${ncdfdir}/include" >> arch-local.path
-    echo 'NETCDF95_INCDIR=$LMDGCM/../../include' >> arch-local.path
-    echo 'NETCDF95_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
-    echo 'IOIPSL_INCDIR=$LMDGCM/../../lib' >> arch-local.path
-    echo 'IOIPSL_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
-    echo 'XIOS_INCDIR=$LMDGCM/../XIOS/inc' >> arch-local.path
-    echo 'XIOS_LIBDIR=$LMDGCM/../XIOS/lib' >> arch-local.path
-    echo 'ORCH_INCDIR=$LMDGCM/../../lib' >> arch-local.path
-    echo 'ORCH_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
+      echo "NETCDF_INCDIR=-I${ncdfdir}/include" >> arch-local.path
+      echo 'NETCDF95_INCDIR=$LMDGCM/../../include' >> arch-local.path
+      echo 'NETCDF95_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
+      echo 'IOIPSL_INCDIR=$LMDGCM/../../lib' >> arch-local.path
+      echo 'IOIPSL_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
+      echo 'XIOS_INCDIR=$LMDGCM/../XIOS/inc' >> arch-local.path
+      echo 'XIOS_LIBDIR=$LMDGCM/../XIOS/lib' >> arch-local.path
+      echo 'ORCH_INCDIR=$LMDGCM/../../lib' >> arch-local.path
+      echo 'ORCH_LIBDIR=$LMDGCM/../../lib' >> arch-local.path
+    fi 
 
     if [ $pcmac == 1 ] ; then
@@ -997,38 +1049,4 @@
 
 fi # of if [ "$pclinux" = 1 ]
-
-
-cd $MODEL/modipsl/modeles/LMDZ*
-lmdzlog=`pwd`/lmdz.log
-
-##################################################################
-# Possibly update LMDZ if a specific svn release is requested
-##################################################################
-
-set +e ; svn upgrade ; set -e
-
-if [ "$svn" = "last" ] ; then svnopt="" ; else svnopt="-r $svn" ; fi
-if [ "$svn" != "" ] ; then
-    set +e ; svn info | grep -q 'http:'
-    if [ $? = 0 ] ; then
-        svn switch --relocate http://svn.lmd.jussieu.fr/LMDZ \
-            https://svn.lmd.jussieu.fr/LMDZ
-    fi
-    svn update $svnopt
-    set -e
-fi
-
-#---------------------------------------------------------------------
-# Retrieve the final svn release number, and adjust compilation
-# options accordingly
-# If svn not available, will use the svn writen in $MODEL/Readm*md
-# For old version it assumes that it is before 4185 (the version
-# for which the test was introduced
-#---------------------------------------------------------------------
-
-set +e ; mysvn=`svnversion . | egrep -o "[0-9]+" 2>/dev/null` ; set -e
-if [ "$mysvn" = "" ] ; then mysvn=`grep 'Revision: [0-9]' $MODEL/Read*.md | awk ' { print $2 } ' 2>/dev/null` ; fi
-if [ "$mysvn" = "" ] ; then mysvn=4190 ; fi
-
 #---------------------------------------------------------------------
 # Option de compilation du rayonnement : depend de $mysvn ><= r4185